﻿namespace TestProject;

/// <summary>
/// 항목
/// </summary>
public class Item
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// ID
    /// </summary>
    public int ID { get; set; }

    #endregion
    #region 명칭 - Name

    /// <summary>
    /// 명칭
    /// </summary>
    public string Name { get; set; }

    #endregion
    #region 코드 - Code

    /// <summary>
    /// 코드
    /// </summary>
    public string Code { get; set; }

    #endregion
    #region 가격 - Price

    /// <summary>
    /// 가격
    /// </summary>
    public int Price { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 해시 코드 구하기 - GetHashCode()

    /// <summary>
    /// 해시 코드 구하기
    /// </summary>
    /// <returns>해시 코드</returns>
    public override int GetHashCode()
    {
        return $"{ID}|{Name}|{Code}|{Price}".GetHashCode();
    }

    #endregion
    #region 동일 여부 구하기 - Equals(source)

    /// <summary>
    /// 동일 여부 구하기
    /// </summary>
    /// <param name="source">소스 객체</param>
    /// <returns>동일 여부</returns>
    public override bool Equals(object source)
    {
        if(!(source is Item))
        {
            return false;
        }

        Item sourceItem = (Item)source;

        return sourceItem.ID    == ID   &&
               sourceItem.Name  == Name &&
               sourceItem.Code  == Code &&
               sourceItem.Price == Price;
    }

    #endregion
    #region 문자열 구하기 - ToString()

    /// <summary>
    /// 문자열 구하기
    /// </summary>
    /// <returns>문자열</returns>
    public override string ToString()
    {
        return $"ID={ID};Name={Name};Code={Code};Price={Price}";
    }

    #endregion
}